searchNodes=[{"doc":"Interface to Outkit's API. Configuration A configuration key is expected with a set of working Outkit API credentials. config :outkit , key : &quot;outkit_api_key&quot; , secret : &quot;outkit_api_secret&quot; , passphrase : &quot;outkit_api_passphrase&quot; Usage This library is primarily used to render and/or send messages. Refer to Outkit.Message for full documentation and usage.","ref":"Outkit.html","title":"Outkit","type":"module"},{"doc":"Assembles configuration data and creates a new Outkit.Client. This is used throughout the client library for functions that do not take an Outkit.Client as the first argument. Examples client = client_from_config ( )","ref":"Outkit.html#client_from_config/0","title":"Outkit.client_from_config/0","type":"function"},{"doc":"","ref":"Outkit.html#format_response/3","title":"Outkit.format_response/3","type":"function"},{"doc":"","ref":"Outkit.html#to_struct/2","title":"Outkit.to_struct/2","type":"function"},{"doc":"This module encapsulates auth and config data for API requests. Example # Create a client with API credentials manually client = Outkit.Client . new ( key : &quot;my-key&quot; , secret : &quot;my-secret&quot; , passphrase : &quot;my-passphrase&quot; ) # Create a client with an config options set client = Outkit.Client . new ( opts : [ return_response : true ] )","ref":"Outkit.Client.html","title":"Outkit.Client","type":"module"},{"doc":"","ref":"Outkit.Client.html#new/0","title":"Outkit.Client.new/0","type":"function"},{"doc":"","ref":"Outkit.Client.html#new/1","title":"Outkit.Client.new/1","type":"function"},{"doc":"This module fascilitates communication with the HTTP API endpoints. It is typically not used directly, but you can if you want. Example # Perform a GET request to retrieve a message { :ok , response } = Outkit.HttpClient . do_request ( client , :get , &quot;/messages/&quot; &lt;&gt; id ) # Perform a POST request to create a message { :ok , response } = Outkit.HttpClient . do_request ( client , :post , &quot;/messages&quot; , %{ message : message } )","ref":"Outkit.HttpClient.html","title":"Outkit.HttpClient","type":"module"},{"doc":"Perform an HTTP request against an Outkit API endpoint. Requires an Outkit.Client as the first argument. Examples do_request ( client , :post , &quot;/messages&quot; , %{ message : message } )","ref":"Outkit.HttpClient.html#do_request/4","title":"Outkit.HttpClient.do_request/4","type":"function"},{"doc":"This module lets you render/send or retrieve a message using Outkit’s API. Example # Create a message { :ok , message } = Outkit.Message . create ( %{ type : &quot;email&quot; , # Message type - &#39;email&#39; and &#39;sms&#39; currently supported project : &quot;my-project&quot; , # Outkit project identifier (managed through our web UI) template : &quot;my-template&quot; , # Template identifier (managed through our web UI) subject : &quot;Welcome, Jane!&quot; , # Email subject (optional, can also be set in the template or omitted for SMS messages) to : &quot;some.name@example.com&quot; , # Recipient address (and optional name) from : &quot;other.name@example.com&quot; , # Sender address (and optional name) data : %{ name : &quot;John Doe&quot; , # ... # Add the values for any variables used in the template here } , } ) # Retrieve a message { :ok , message } = Outkit.Message . get ( &quot;some-id&quot; )","ref":"Outkit.Message.html","title":"Outkit.Message","type":"module"},{"doc":"Create a message based on a map. The client will be derived from your configuration. Examples create ( %{ type : &quot;email&quot; , project : &quot;acme-project&quot; , template : &quot;welcome&quot; , } )","ref":"Outkit.Message.html#create/1","title":"Outkit.Message.create/1","type":"function"},{"doc":"Create a message based on a map. Uses an Outkit.Client. Examples client = Outkit.Client . new ( key : &quot;my-key&quot; , secret : &quot;my-secret&quot; , passphrase : &quot;my-passphrase&quot; ) create ( client , %{ type : &quot;email&quot; , project : &quot;acme-project&quot; , template : &quot;welcome&quot; , } )","ref":"Outkit.Message.html#create/2","title":"Outkit.Message.create/2","type":"function"},{"doc":"Retrieve a message using an id. The client will be derived from your configuration. Examples get ( &quot;some-id&quot; )","ref":"Outkit.Message.html#get/1","title":"Outkit.Message.get/1","type":"function"},{"doc":"Retrieve a message using an Outkit.Client and an id. Examples client = Outkit.Client . new ( key : &quot;my-key&quot; , secret : &quot;my-secret&quot; , passphrase : &quot;my-passphrase&quot; ) get ( client , &quot;some-id&quot; )","ref":"Outkit.Message.html#get/2","title":"Outkit.Message.get/2","type":"function"},{"doc":"Creates a new Outkit.Message struct. Mostly used indirectly through the get and create functions. Examples new ( %{ type : &quot;email&quot; , project : &quot;acme-project&quot; , template : &quot;welcome&quot; , } )","ref":"Outkit.Message.html#new/1","title":"Outkit.Message.new/1","type":"function"},{"doc":"This is the official Elixir client for the Outkit API.","ref":"readme.html","title":"Outkit API Client","type":"extras"},{"doc":"First, add Outkit to your mix.exs dependencies: def deps do [ { :outkit , &quot;~&gt; 0.0.3&quot; } ] end Then, update your dependencies: $ mix deps.get Add :outkit to your list of applications if using Elixir 1.3 or lower. defp application do [ applications : [ :outkit ] ] end","ref":"readme.html#installation","title":"Outkit API Client - Installation","type":"extras"},{"doc":"In one of your configuration files, include your Outkit API credentials like this: config :outkit , key : &quot;OUTKIT_API_KEY&quot; , secret : &quot;OUTKIT_API_SECRET&quot; , passphrase : &quot;OUTKIT_API_PASSPHRASE&quot;","ref":"readme.html#configuration","title":"Outkit API Client - Configuration","type":"extras"},{"doc":"General All functions of the API client take an %Outkit.Client{} struct as the first argument. This struct contains auth info and options. If you don’t supply a client as the first argument, the library will auto-build one from the configuration and use it automatically. So in the following example the two methods are identical, provided that you have specified the same settings in your configuration files as those passed to the Outkit.Client.new function: # Method one Outkit.Message . create ( message ) # Method two client = Outkit.Client . new ( key : &quot;my-key&quot; , secret : &quot;my-secret&quot; , passphrase : &quot;my-passphrase&quot; ) Outkit.Message . create ( client , message ) This gives you complete flexibility in terms of how you want to use Outkit - one static configuration for your entire app or several clients that can be dynamically configured at runtime. Submitting a message Submitting a message for rendering and/or delivery will return a message record with the Outkit ID and the status set to received (as well as a few other properties that can be determined at creation time). The API call returns as soon as the message is saved on our servers, it does not wait for rendering or delivery to take place (by default - see the section on synchronous processing below). You can retrieve the status of a message at any time. We also support webhook notifications on status changes. # Create a message { :ok , message } = Outkit.Message . create ( %{ type : &quot;email&quot; , # Message type - &#39;email&#39; and &#39;sms&#39; currently supported project : &quot;my-project&quot; , # Outkit project identifier (managed through our web UI) template : &quot;my-template&quot; , # Template identifier (managed through our web UI) subject : &quot;Welcome, Jane!&quot; , # Email subject (optional, can also be set in the template or omitted for SMS messages) to : &quot;some.name@example.com&quot; , # Recipient address (and optional name) from : &quot;other.name@example.com&quot; , # Sender address (and optional name) data : %{ name : &quot;John Doe&quot; , # ... # Add the values for any variables used in the template here } , } ) Retrieving a message You can retrieve the status and data of a message at any time. After the message has been rendered, we will also return the applicable rendered fields ( subject , html_body and text_body for emails, text_body for SMS messages) so that you can see exactly what was/will be sent. { :ok , message } = Outkit.Message . get ( &quot;some-id&quot; )","ref":"readme.html#usage","title":"Outkit API Client - Usage","type":"extras"},{"doc":"The return value for all API functions in this library is always a tuple: # Either { :ok , some_data } # or { :error , error_message } The data part of the tuple will (by default) contain only the actual data returned from the API, converted to Elixir data structures. So both Outkit.Message.get/1 and Outkit.Message.create/1 return an %Outkit.Message{} struct, like so % Outkit.Message { type : &quot;email&quot; project : &quot;acme-project&quot; , template : &quot;welcome&quot; , html_body : &quot;... rendered HTML ...&quot; , text_body : &quot;... rendered plain text ...&quot; , backend_response : %{ # Note that child Maps are regular maps with string keys &quot;normalized_id&quot; =&gt; &quot;abc123&quot; , ... } ... } If you need access to the full response from our API (including HTTP headers, HTTP status code etc.), you can set the return_response in the opts key on the client, like so: client = Outkit.Client . new ( opts : [ return_response : true ] ) # Or you could do the same in your configuration { :ok , response } = Outkit.Message . create ( client , message ) The response variable will contain something like this: %{ body : %{ ... } , raw_body : &quot;...&quot; , headers : %{ ... } , status_code : 200 , } You’d find the actual data in response.body[&quot;data&quot;] . Note that the data is just regular Lists or Maps with string keys - no structs.","ref":"readme.html#return-values","title":"Outkit API Client - Return values","type":"extras"},{"doc":"To support the use case of rendering a message using the Outkit infrastructure, but sending it yourself, you can specify render_only: true in the message record. You may also want to set sync: true in these cases - see the next section. Once the message has been rendered, its data will contain a text_body field (all types), and subject and html_body fields for emails. These can then be fed directly to, say, a Mailgun client or SMTP server. See details below.","ref":"readme.html#rendering-a-message","title":"Outkit API Client - Rendering a message","type":"extras"},{"doc":"For some use cases (sending emails from scripts, using Outkit as a renderer etc.), it can be desirable to have the API calls operate synchronously - ie. perform rendering/delivery immediately instead of queueing messages, and return the rendered message and (optionally) its delivery status in the data from the API call. This can be accomplished by setting sync: true in the submitted message. Note that this will incur additional costs (see our pricing page for details), and that each Outkit customer is only allowed a limited number of such requests (currently 100.000 per month), since they are more difficult and costly for us to scale. Customers that need additional synchronous requests can contact support to have their monthly limit raised. We expect to raise the default limit significantly when we have more usage data.","ref":"readme.html#synchronous-processing","title":"Outkit API Client - Synchronous processing","type":"extras"},{"doc":"Submitted messages typically go through the following stages, which are reflected in the status field: received - The message has been received and saved in our datastore, where it awaits further processing queued_for_rendering - The message has been queued for rendering rendered - The subject and HTML/text of the template have been rendered and merged with the submitted data queued_for_delivery - The message has been queued for delivery delivered - Message has been successfully delivered to the backend Typically, a message will go through all stages in a matter of milliseconds, but it can sometimes take a little longer. Note that different message can have different statuses. For example, a message with the render_only flag set will never be queued for delivery or delivered. Messages that supply their own text_body and html_body instead of using a template will never be rendered, only delivered. Note that the delivered status does not necessarily mean that the message has been delivered to the end user . Once the backend has accepted the message, it’s up to the backend to perform final delivery. Most backends offer webhooks if you need confirmation of the actual delivery. There are some additional statuses your message can have, in case of errors and problems: render_error - We were unable to render the template with the submitted data backend_error - We encountered an error when trying to submit the message to the configured backend internal_error - There was an unrecoverable problem on our end (should be very rare) If the message has any of these statuses, there will be more information in the status_message field. Also, you can inspect the full backend response in the response field. All messages have a done flag (true or false) which indicate whether we have finished processing it. Nothing more will happen to a message once it is done, regardless of its status.","ref":"readme.html#message-lifecycle","title":"Outkit API Client - Message lifecycle","type":"extras"},{"doc":"The functions names for messages ( get and create ) are deliberately generic, to align them with future expansions of the API (say, Outkit.Project.create ). So even though you might feel like you are submitting or sending a message (and we often use terms like that in our own docs), in API terms you are always just create -ing it. You’ll probably wrap our functions in your own MyApp.send_sms or MyApp.enqueue_email or whatever anyway, so it shouldn’t be much of an issue. We feel that when dealing with APIs and their clients, consistency trumps linguistic precision.","ref":"readme.html#a-note-on-function-names","title":"Outkit API Client - A note on function names","type":"extras"},{"doc":"Write proper tests with mocks (the current tests run &quot;live&quot; against our dev servers)","ref":"readme.html#todo","title":"Outkit API Client - TODO","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Dynamically use the correct hmac function from OTP, so we can support any version of Elixir/OTP","ref":"changelog.html#0-0-4-2021-11-23","title":"Changelog - 0.0.4 (2021-11-23)","type":"extras"},{"doc":"MIT License Copyright (c) 2018 Outkit Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]